VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TI83+ ION Fixer"
   ClientHeight    =   4890
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4890
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkVerbose 
      Caption         =   "Verbose"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   4560
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.CheckBox chkConfirm 
      Caption         =   "Confirm Changes"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   4200
      Width           =   1575
   End
   Begin VB.CommandButton cmdFix 
      Caption         =   "&Fix Programs"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   5
      Top             =   4200
      Width           =   1455
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse..."
      Height          =   375
      Left            =   3600
      TabIndex        =   4
      Top             =   360
      Width           =   975
   End
   Begin VB.TextBox txtDir 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   3375
   End
   Begin VB.TextBox txtMessages 
      BackColor       =   &H8000000F&
      Height          =   3135
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   960
      Width           =   4455
   End
   Begin MSComDlg.CommonDialog cmd 
      Left            =   2400
      Top             =   4200
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "TI-83+ Programs (*.8xp)|*.8xp"
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Directory:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   675
   End
   Begin VB.Label lblMessages 
      AutoSize        =   -1  'True
      Caption         =   "Messages:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   765
   End
End
Attribute VB_Name = "frm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Verbose As Boolean
Dim Confirm As Boolean

Option Explicit
Private Sub cmdBrowse_Click()
    Dim X As Long
    Dim Path As String
    cmd.ShowOpen
    Path = cmd.filename
    
    'Strip the junk off the end
    For X = Len(Path) To 1 Step -1
        If Mid(Path, X, 1) = "\" Then
            txtDir.text = Mid(Path, 1, X)
            Exit For
        End If
    Next

    
End Sub

Sub Clear()
    txtMessages.text = ""
End Sub

Sub Disp(text As String)
    txtMessages.text = txtMessages.text + text + vbCrLf
    txtMessages.SelStart = Len(txtMessages)
End Sub

Private Sub cmdFix_Click()
    Dim Path As String
    Dim Files As String
    Dim File As String
    Dim FileCount As Long
    Dim X As Long
    Verbose = chkVerbose.Value
    Confirm = chkConfirm.Value
    Path = txtDir.text
    Files = Path + "*.8xp"
    
    'strip off the stuff after the last \
    For X = Len(Path) To 1 Step -1
        If Mid(Path, X, 1) = "\" Then
            Path = Mid(Path, 1, X)
            Exit For
        End If
    Next
        
    Clear
    Disp "Processing files: " + Files
    
    File = dir(Files)
    Do
        If File = "" Then Exit Do
        FileCount = FileCount + 1
        DoFile Path + File
        
        
        
        File = dir()
    Loop
    Disp "Finished."
    If FileCount = 0 Then Disp "No Files Found matching " + Files
        
    
End Sub

Private Sub Form_Load()
    LoadSettings
End Sub

Sub LoadSettings()
    txtDir.text = GetSetting("IonFixer", "Defaults", "Directory", App.Path)
    chkConfirm.Value = GetSetting("IonFixer", "Defaults", "Confirm", 0)
    chkVerbose.Value = GetSetting("IonFixer", "Defaults", "Verbose", 0)
End Sub

Sub SaveSettings()
    SaveSetting "IonFixer", "Defaults", "Directory", txtDir.text
    SaveSetting "IonFixer", "Defaults", "Confirm", chkConfirm.Value
    SaveSetting "IonFixer", "Defaults", "Verbose", chkVerbose.Value
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SaveSettings
End Sub

Sub DoFile(File As String)
    Dim First As Long
    Dim L As Long
    Dim FileOff As Long
    Dim OldChecksum As Long
    Dim Checksum As Long
    Dim Prog() As Byte
    Dim Changed As Boolean
    Dim MsgBoxResult As VbMsgBoxResult
    On Error GoTo DoFileError
    If Verbose Then Disp "Scanning file " + File
    Open File For Binary As #1
        L = LOF(1) - 1
        If Verbose Then Disp "File length: " + Str(L) + " bytes"
        'byte 72 is the first byte of the program
        If L < &H48 Then
            Close #1
            If Verbose Then Disp "File " + File + " is too short to contain a TI83+ program."
            Exit Sub
        End If
        If L > 32768 Then
            Close #1
            If Verbose Then Disp "File " + File + " is too large to contain a TI83+ program."
            Exit Sub
        End If
        ReDim Prog(L)
        Get #1, 1, Prog
        
        If (Prog(&H44) = 0) And (Prog(&H45) = 0 Or Prog(&H45) = 8) Then
            First = &H4A
        Else
            First = &H48
        End If
        
        
        Checksum = Prog(L) * 256& + Prog(L - 1)
        If Verbose Then Disp "Original Checksum: " + Hex2(Checksum)
        OldChecksum = Checksum
        Checksum = GetChecksum(Prog, &H37, L - 2)
        If Verbose Then Disp "Original Calculated Checksum: " + Hex2(Checksum)
        
        If Checksum <> OldChecksum Then
            Disp "File " + File + " has an invalid checksum!"
            Changed = True
        End If
        
        If Prog(First) = &HBB And Prog(First + 1) = 6 Then
            Disp "File " + File + " has an invalid ion header!"
            Prog(First + 1) = &H6D
            Changed = True
        End If
        
        Checksum = GetChecksum(Prog, &H37, L - 2)
        If Verbose Then Disp "New Checksum: " + Hex2(Checksum)
        Prog(L) = (Checksum \ 256)
        Prog(L - 1) = (Checksum And 255)
        
        If Changed = True Then
            If Confirm = True Then
                MsgBoxResult = MsgBox("About to make changes to " + File + ".  Proceed?", vbYesNoCancel + vbQuestion)
                If MsgBoxResult <> vbYes Then
                    Close #1
                    Exit Sub
                End If
            End If
        
            Put #1, 1, Prog
            Disp "File has been corrected."
        End If

    Close #1
Exit Sub
DoFileError:
    Close #1
    MsgBox "An error occurred: " + Error
    Exit Sub
End Sub

Function GetChecksum(ByRef Prog() As Byte, ByVal First As Long, ByVal Last As Long)
    Dim Pos As Long
    Dim Sum As Long
    For Pos = First To Last
        Sum = (Sum + Prog(Pos)) And 65535
    Next
    GetChecksum = Sum
End Function

Function Hex2(ByVal number As Long) As String
    Dim retval As String
    retval = Hex(number)
    While Len(retval) < 4
        retval = "0" + retval
    Wend
    Hex2 = retval
End Function
